// Input.cpp: implementation of the CInput class.
//
// (c) 2000 Tom A. Wheeler
//////////////////////////////////////////////////////////////////////

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

#include "Input.h"


//////////////////////////////////////////////////////////////////////
// Construction/Destruction 
//////////////////////////////////////////////////////////////////////

CInput::CInput()
{

}

CInput::~CInput()
{

}

////////////////////////////////////////////////////////////////
// Input version 1: Passes value into INTEGER type, prints
// optional prompt. Maximum input length is limited to 10
// characters. Uses internal buffer.
////////////////////////////////////////////////////////////////

int CInput::Input( int& nValue, char* szPrompt )
{
int nResult;

if (szPrompt)
	printf("%s", szPrompt );

InputString(m_Buffer, 10 );

nResult = atoi( m_Buffer );

nValue = nResult;

return(nResult);
}


////////////////////////////////////////////////////////////////
// Input version 2: Passes value into DOUBLE type, prints
// optional prompt. Maximum input length is limited to 10
// characters. Uses internal buffer.
////////////////////////////////////////////////////////////////


double CInput::Input( double& dValue, char* szPrompt )
{
double dResult;

if (szPrompt)
	printf("%s", szPrompt );

InputString(m_Buffer, 10 );

dResult =  atof( m_Buffer );

dValue = dResult;

return(dResult);
}


////////////////////////////////////////////////////////////////
// Input version 3: Passes value into CHAR (STRING) type, prints
// optional prompt. Maximum input length specified by caller.
// Uses external buffer (address supplied by caller).
////////////////////////////////////////////////////////////////

char* CInput::Input( char* szValue, int nMaxLen, char* szPrompt )
{

//
// Echo prompt if passed
//

if (szPrompt)
	printf("%s", szPrompt );

InputString( szValue, nMaxLen );

return(szValue);
}

///////////////////////////////////////////////////////////////	
//
// Internal Method: InputString
//
// Input a string from the console, constrained by MaxLen
//
///////////////////////////////////////////////////////////////

int CInput::InputString(char* szBuffer, int nMaxLen)
{
int Len;
char c;

Len = 0;

for(;;)
	{
	c = getch();

	if (c==CR)
		{
		szBuffer[Len] = '\0';
		printf("\n");
		return Len;	// return length of user's input string
		}

	if ((c==BS)&&(Len))
		{
		Len--;
		printf("%c%c%c", c, ' ', c );
		continue;
		}

	if (c < ' ')
		continue;


	if (Len >= nMaxLen)
		continue;


	printf("%c", c);
	szBuffer[Len] = c;
	Len++;

	}

}
	
